#ifndef SYSMONCOLOR_H_
#define SYSMONCOLOR_H_

#include <SupportDefs.h>
#include <InterfaceDefs.h>
#include <math.h>

class SysMonColor {
public:
	SysMonColor() { /* empty inlined */ }
	SysMonColor(float const,float const,float const);
	SysMonColor(int const,int const,int const);
	SysMonColor(rgb_color const &);
	SysMonColor(uint32 const);
	SysMonColor(int32 const);
	// SysMonColor(SysMonColor const &); // use default
	// SysMonColor & operator = (SysMonColor const &);
	// ~SysMonColor(); // use default

	operator rgb_color() const;
	operator uint32() const;

	static float InvGamma(float const);
	static float Gamma(float const);

	friend SysMonColor operator +(SysMonColor const &,SysMonColor const &);
	friend SysMonColor operator -(SysMonColor const &,SysMonColor const &);
	friend SysMonColor operator *(float const,SysMonColor const &);
	friend SysMonColor operator /(float const,SysMonColor const &);
	friend SysMonColor operator *(SysMonColor const &,float const);
	friend SysMonColor operator /(SysMonColor const &,float const);
private:
	float r,g,b;
};

#endif
